import javax.microedition.lcdui.CommandListener;

/*
 * Created on 22 mai 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */

/**
 * @author Administrateur
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */

import javax.bluetooth.*;
import javax.microedition.io.*;

import java.io.*;

/**
 * Classe de gestion asynchrones des communications.
 * 
 * @author Batrice Frey et Cyril Crassin
 *
 */
public class TicTacCom implements Runnable {

	/**Application source.*/
	protected TicTacMain parent;
	/**Role: Client->1, Serveur->0 .*/ 
	protected int role;
	
	protected static final int ROLE_SERVEUR=0;
	protected static final int ROLE_CLIENT=1;
	
	/** Identification partage par le client et le serveur.*/  
	protected static final UUID RFCOMM_UUID = new UUID(0x0003);	
	
	
	//Donnes partages
	protected StreamConnection conn;
	protected LocalDevice localDevice;
	protected InputStream input;
	protected OutputStream output;
	  
	  
	private boolean stopThread=false;
	 
	Thread thread = new Thread(this) ;
	
	boolean initOK=false;
	
	boolean newData=false;
	int toSendData[]=new int[4];
	
	boolean readRequest=false;
	int readData[]=new int[4];
	
	
	boolean newReceivedData=false;
	
	
	/**Recuperation des infos recues.*/
	public int [] getReceivedData(){
 		return readData;
	}
	
	/**
	 * Envoi d'un coup.
	 * @param player Joueur qui a jou.
	 * @param x Position en X du coup.
	 * @param y Position en Y du coup.
	 * @param z Position en Z du coup
	 */
	public void send(int player, int x, int y, int z){
		synchronized(this){
		toSendData[0]=player;
		toSendData[1]=x;
		toSendData[2]=y;
		toSendData[3]=z;
		
		newData=true;
		}
	}
	
	/**Mise en attende du coup de l'autre joueur.*/
	public void receive(){
		synchronized(this){
 		newReceivedData=false;
 		readRequest=true;
		}
	}
	
	void initBeforeThread(){}
	void initAfterThread(){}
	void initCom() throws IOException{}
	
	/**
	 * Constructeur.
	 * @param p Application source.
	 * @param r Role.
	 */
	public TicTacCom(TicTacMain p, int r) {
		parent = p;
		role=r;
		
		initBeforeThread();
		
		//On thread
	    thread.start() ;
	}
	
	
	/**Debut du thread.
	 * Initialisation et envois/receptions de donnes.
	 * */
	public void run() {
		
		try {
			initAfterThread();
				
			while(!initOK)
				;
			
				
			initCom();
		
			output = conn.openOutputStream(); 
			input = conn.openInputStream();
				
			while(!stopThread){
				synchronized(this){
				
				if(newData){

					for(int i=0; i<toSendData.length; i++)
						output.write(toSendData[i]);	
					newData=false;
				}
				
				if(readRequest){
					for(int i=0; i<readData.length; i++)
						readData[i]=input.read();
					readRequest=false;
					newReceivedData=true;
				}
				}
			}
			
		}catch (Exception ex) {
			System.err.println("Bluetooth Running Error: " + ex +" on "+role);	
	    } finally {
	      try {
	        
	      	if (input != null) {
	      		input.close();
	        }
	        if (output != null) {
	        	output.close();
	        }
	        if (conn != null) {
	        	conn.close();
	        }
	        
	      } catch (IOException ioe) {
	        System.err.println( "Error Closing connection "+role+": IOException: " + ioe );
	      }
	    }
	}
	
	public void debug(String st) {
	    System.out.println ("DEBUG TicTacCom : "+st) ;
	}
	
	
	
	
	
	
	  
	  
}
