import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;

import java.util.*;

import javax.bluetooth.*;
/**
 * Classe principale de l'application TicTacToe 3D.
 * @author Batrice Frey et Cyril Crassin
 */
public class TicTacMain extends MIDlet implements CommandListener{
	/**Instance courante.*/
	static TicTacMain midlet;
	/**Canvas du jeu.*/
	TicTacCanvas monCanvas;// = new TicTacCanvas();
	
	/**Timer de rafraichissement.*/
	Timer iTimer = new Timer();

	/**Module de communication asynchrone.*/
	TicTacCom com;
		
	/** Soft-keys de commandes.*/
	private final Command selectCmd = new Command("Select", Command.SCREEN, 2);
	private final Command exitCmd = new Command("Exit", Command.EXIT, 1);        

	/** Menu de choix du joueur.*/
	private static final String[] menuLabels = { "Joueur 1", "Joueur 2" };    
	private final List menu = new List("TicTacToe 3D, par Batrice Frey et Cyril Crassin", List.IMPLICIT, menuLabels, null);

	/**Constructeur.*/
	public TicTacMain() {
		TicTacMain.midlet = this;
		
		menu.addCommand(exitCmd);
	    menu.addCommand(selectCmd);
	    menu.setCommandListener(this);
	}

	/**Dmarage de l'application.*/
	public void startApp() {
		Display.getDisplay(this).setCurrent(menu);
	}

	/**Mise en pause.*/
	public void pauseApp() {
	}

	/**Destruction.*/
	public void destroyApp(boolean unconditional) {
	}


	/**Arret de l'application.*/
	public static void quitApp() {
		midlet.destroyApp(true);
		midlet.notifyDestroyed();
		midlet = null;
	}
	
	/**Redemarage.*/
	public void restartApp() {
		com=null;
		monCanvas=null;
		
		System.gc();
		startApp();
	
	}
	
	
	/**Inner class de timer.*/
	class MyTimerTask extends TimerTask {
		public void run() {
			if( monCanvas != null ) {
				monCanvas.repaint();
			}
		}
	}
	
	/**Ecoutes des actions.*/
	public void commandAction(Command c, Displayable d) {
		if (c == exitCmd) {
			destroyApp(true);
			notifyDestroyed();
			return;
	    }
		
		//Il n'y a que 2 boutons
		if(menu.getSelectedIndex()==0)
			com=new TicTacComServer(this, menu.getSelectedIndex());
		else
			com=new TicTacComClient(this, menu.getSelectedIndex());
		
		monCanvas= new TicTacCanvas(this, menu.getSelectedIndex()+1, com);
		iTimer.schedule( new MyTimerTask(), 0, 40 );
		
		Display.getDisplay(this).setCurrent(monCanvas);
		
	}  
}